<?php
define('BWCURLCLIENT_VERSION', 1);

define('BWCURLCLIENT_PARAMFORAM_INT', 1);
define('BWCURLCLIENT_PARAMFORAM_STRING', 2);
define('BWCURLCLIENT_PARAMFORAM_FLOAT', 5);
define('BWCURLCLIENT_PARAMFORAM_LINKCARD', 11);

class CBW_PHPCurlClient { 
	
    public $BWServer = ''; 
    public $BWWebProtocol = ''; 
    public $BWLogin = ''; 
    public $BWUserPhrase = '';
	public $BWDestinationUploadFolder='';
	public $BWLastError='';
	public $BWSend_Values=array();
	public $BWSend_FilesList=array();
	public $BWRecive_Values=array();
	public $BWRecive_FilesList=array();
	public $BWRecive_Notifies=array();

	public function __construct($e_strServer,$e_strWebProtocol, $e_strLogin, $e_strUserPhrase) 
	{
		$this->BWServer = $e_strServer;
		$this->BWWebProtocol = $e_strWebProtocol;
		$this->BWLogin = $e_strLogin;
		$this->BWUserPhrase = $e_strUserPhrase;
	}
 
	function SetBWDatabaseURL($e_strServer,$e_strWebProtocol, $e_strLogin, $e_strUserPhrase)
	{
//		echo "Set server: [$e_strServer]<br>\n";
		$this->BWServer = $e_strServer;
		$this->BWWebProtocol = $e_strWebProtocol;
		$this->BWLogin = $e_strLogin;
		$this->BWUserPhrase = $e_strUserPhrase;
		
		return true;
	}

    function SetSendParam_Int($e_strParamCName, $e_iValue)
	{	
		$this->BWSend_Values[$e_strParamCName]=array(	
			'value'=>$e_iValue,
			'info'=>array('format'=>BWCURLCLIENT_PARAMFORAM_INT)
		);
		return true;
	}

    function SetSendParam_String($e_strParamCName, $e_strValue)
	{	
		$this->BWSend_Values[$e_strParamCName]=array(	
			'value'=>$e_strValue,
			'info'=>array('format'=>BWCURLCLIENT_PARAMFORAM_STRING)
		);
		return true;
	}

    function SetSendParam_Float($e_strParamCName, $e_flValue)
	{	
		$this->BWSend_Values[$e_strParamCName]=array(	
			'value'=>$e_flValue,
			'info'=>array('format'=>BWCURLCLIENT_PARAMFORAM_FLOAT)
		);
		return true;
	}

    function GetReturnParam_AsString($e_strParamCName, &$e_strValue)
	{	
		if (!array_key_exists($e_strParamCName, $this->BWRecive_Values))
		{
			$e_strValue="Return param [$e_strParamCName] is absend<br>";
			$e_strValue.='<pre>'.print_r($this->BWRecive_Values, true).'</pre>';
			return false;
		}
		
		switch($this->BWRecive_Values[$e_strParamCName]['info']['format'])
		{
			case BWCURLCLIENT_PARAMFORAM_STRING:
				$e_strValue=$e_strValue=$this->BWRecive_Values[$e_strParamCName]['value'];
				return true;
			break;
		}

		return false;
	}

    function BWSendToGlobalFunction($e_strFunctionID, $e_strFunctionKey)
	{
		$this->BWRecive_Values=array();
		$this->BWRecive_FilesList=array();
		$this->BWLastError='Not defined error';
	
		if ($e_strFunctionID=='') {$this->BWLastError='Not set <b>e_strFunctionID</b> ';return false;}
		if ($e_strFunctionKey=='') {$this->BWLastError='Not set <b>e_strFunctionKey</b> ';return false;}
		if ($this->BWServer=='') {$this->BWLastError='Not set member <b>BWServer</b> in <b>CBW_PHPClient</b> ';return false;}
		if ($this->BWWebProtocol=='') {$this->BWLastError='Not set member <b>BWWebProtocol</b> in <b>CBW_PHPClient</b> ';return false;}
		if ($this->BWLogin=='') {$this->BWLastError='Not set member <b>BWLogin</b> in <b>CBW_PHPClient</b> ';return false;}
		if ($this->BWUserPhrase=='') {$this->BWLastError='Not set member <b>BWUserPhrase</b> in <b>CBW_PHPClient</b> ';return false;}

		$m_arrParamSend=$this->BWSend_Values;
		
		$m_arrPostParam=array(
			'bwcurlclient_head'=>
				array(
					'bwcurlclienthead_login'=>$this->BWLogin,
					'bwcurlclienthead_password'=>$this->BWUserPhrase,
					'bwcurlclienthead_function_uuid'=>$e_strFunctionID,
					'bwcurlclienthead_function_key'=>$e_strFunctionKey,
				),
			'bwcurlclient_values'=>$m_arrParamSend		
		);
		
//		print_r($m_arrPostParam);
		
		if( $m_Curl = curl_init() ) 
		{
			$m_strPostFields=http_build_query($m_arrPostParam);
//			echo "Send to server: [<b>".$this->BWServer."</b>]. Line:". __LINE__ ."<br>\n";
//			echo "Send to server: [<pre>". print_r($m_arrPostParam, true) ."</pre>]. Line:". __LINE__ ."<br>\n";


			curl_setopt($m_Curl, CURLOPT_URL, $this->BWWebProtocol.'://'.$this->BWServer.'/modules_php/php_bw_curls/bwphpcurl_global_function.php');
			curl_setopt($m_Curl, CURLOPT_RETURNTRANSFER,true);
			curl_setopt($m_Curl, CURLOPT_POST, true);
			curl_setopt($m_Curl, CURLOPT_POSTFIELDS, $m_strPostFields);
			curl_setopt($m_Curl, CURLOPT_SSL_VERIFYPEER, false);// Disabled SSL Cert checks
			$m_strResultBuild = curl_exec($m_Curl);
			curl_close($m_Curl);
//			echo "return from server: [<pre>". $m_strResultBuild ."</pre>]. Line:". __LINE__ ."<br>\n";
			if (trim($m_strResultBuild)=='')
			{
				$this->BWLastError="Error answer from server [". $this->BWServer ."]:return empty string (NOT JSON)(Line phpclient_api:<b>". __LINE__ ."</b>)";
				$this->BWRecive_Values=array();
				return false;			
			}
			
			$m_arrProtoReturn=json_decode($m_strResultBuild, true);
			if (!is_array($m_arrProtoReturn))
			{
				$this->BWLastError="Error answer from server [". $this->BWServer ."]:<pre>$m_strResultBuild</pre>\n(Line phpclient_api:<b>". __LINE__ ."</b>)";
				$this->BWRecive_Values=array();
				return false;
			}
			
			if (array_key_exists('Notifies', $m_arrProtoReturn))
			{
				$this->BWRecive_Notifies=$m_arrProtoReturn['Notifies'];
			}
			
			if (array_key_exists('Error', $m_arrProtoReturn))
			{
				$this->BWLastError=$m_arrProtoReturn['Error'];
				if (trim($this->BWLastError)=='') {$this->BWLastError="From server [". $this->BWServer ."]:return empty description error\n(Line phpclient_api:<b>". __LINE__ ."</b>)";}
				return false;
			}
			


//			echo "Return from server:<pre  style=\"word-wrap: break-word;  white-space: pre-wrap;\">$m_strResultBuild</pre> Line:". __LINE__ ."<br>\n";
			if (array_key_exists('Values',$m_arrProtoReturn))
			{
				$this->BWRecive_Values=$m_arrProtoReturn['Values'];
			}
			else
			{
				$this->BWRecive_Values=array();	
			}
			
//			print_r($m_arrResultBuild);
		}
		else
		{
			$this->BWLastError="Fail init curl (Line:". __LINE__ .")";
			return false;			
		}
		return true;
	}
	
	function PostAnalyse()
	{
		if (count($this->BWRecive_Notifies)>0)
		{
			foreach ($this->BWRecive_Notifies as &$m_arrNotifies)
			{
				echo "<div style=\"border:1px solid #777;\">";
				echo $m_arrNotifies['topic'];
				echo "</div>\n";
			}
		}
	}
} 
?>